String sms_tel;
String sms_mess;
String sms_ussd;

//   SMS .  SMS     .
// Telephone:  ,    
// Text:   ( 160 ,    ,  80 )
// bFlash: true-     
//         false- SMS 
// bTranslit: true-     
//            false-   
bool SendMessage(String Telephone, String Text, bool bFlash, bool bTranslit)
{
  TSMS p = new TSMS;
  p.Telephone = Telephone;
  p.Text = Text;
  p.Flash = bFlash;
  p.Transliterate = bTranslit;
  bool rv = SMSSend(p);
  delete p;
  return rv;
}

//  SMS 
void ReceiveMessage()
{
  //   SMS 
  if( SMSCount() > 0 )
  {
    print("  SMS  !");
    TSMS p = new TSMS;
    if( SMSReceive(p) )
    {
      print(" : " + p.Telephone);
      print(": " + p.Text);
      List.List.Items.Add("SMS TEL: " + p.Telephone + " TEXT: " + p.Text);

      print("  SMS   :");
      String s;
      int WordNumber = 1;
      while( true )
      {
        s = ExtractSubString(p.Text, WordNumber, " ");
        if( Length(s)>0 ) print( s );
        else break;
        WordNumber++;
      }
    }
    delete p;
  }
  else
  {
    print(" SMS   !");
  }
}

//    
void ReceiveRings()
{
  int c = RingCount();
  if( c > 0 )
  {
    print("   : " + IntToStr(c));
    TRing r = new TRing;
    if( RingReceive(r) )
    {
      print("***    ***");
      print("    : " + DateTimeToStr(r.DateTime));
      if( r.International )
        print("     (   ,  +7)");
      else
        print("    ");
      print(" : " + r.Telephone);
      print("   RING: " + IntToStr(r.Count));
      List.List.Items.Add("RING TEL: " + r.Telephone + " COUNT: " + IntToStr(r.Count));
    }
    delete r;
  }
  else
  {
    print("   !");
  }
}

//       GSM
String GetModemStateStr()
{
  switch( GSMState() )
  {
    case 0: return " GSM  ";
    case 1: return "   ";
    case 2: return "  ";
    case 3: return "    (   SMS)";
    case 4: return " GSM   ";
  }
  return "?";
}

//       GSM
TColor GetModemStateColor()
{
  switch( GSMState() )
  {
    case 0: return clBlue;
    case 1: return clYellow;
    case 2: return clRed;
    case 3: return clGreen;
    case 4: return clFuchsia;
  }
  return clWhite;
}

//     SMS 
void OnSendSMS(TMonText Sender)
{
  /*
  if( GSMState() != 3 )
  {
    LMShowMessage(" GSM     !", clRed);
    return;
  }
  */
  if( Length(sms_tel)==0 )
    sms_tel = "+7 495 XXX XX XX";
  if( ! InputString("  ", sms_tel) )
    return;

  if( Length(sms_mess)==0 )
    sms_mess = "   LanMon !";
  if( ! InputString("  ", sms_mess) )
    return;

  //  SMS 
  if( SendMessage(sms_tel, sms_mess, true, false) )
    LMShowMessage("SMS      ");
  else
    LMShowMessage("  SMS  !", clRed);
}

//-----------------------------------------------------------------------------
//     GSM   
//    sms.log
//      "/<>
//-----------------------------------------------------------------------------
void OnShowProtokol(TMonText Sender)
{
  if( frload("protokol.fr3") )
  {
    //        ...
    //   
    SystemReport.Variables["Title"] = "\"   GSM\"";
    //   "\"   
    SystemReport.Variables["ProtokolFile"] = DoubleCharInString("\"" + LMWorkDir() + "sms.log" + "\"", "\\");
    //  
    if( frPrepare(1) )
      frShowPrepared();
  }
}

//-----------------------------------------------------------------
//    c   s   
//-----------------------------------------------------------------
String DoubleCharInString(String s, char c)
{
  for(int i=1; i<=Length(s); i++)
  {
    if( s[i]==c )
    {
      Insert(c, s, i);
      i++;
    }
  }
  return s;
}

//-----------------------------------------------------------------
//   str ,    chr
//-----------------------------------------------------------------
String DeleteCharactersFromString(String str, String chr)
{
  for(int i=1; i<=Length(chr); i++)
    while( Pos(chr[i], str)>0 )
      DeleteString(str, Pos(chr[i], str), 1);
  return str;
}

//-----------------------------------------------------------------
//     
//-----------------------------------------------------------------
String RssiToDb(int rssi)
{
  if( rssi==99 )
    return "";
  return " (-" + IntToStr(113-(rssi*2)) + " )";
}

//-----------------------------------------------------------------
//   
//-----------------------------------------------------------------
void ReadSignalQual()
{
  if( GSMState()!=3 )
  {
    Qual.CurValue = 0;
    Qual.Text = "   !";
    return;
  }

  String a;
  if( ! ATCmd("at+csq\r",a,1000) )
  {
    print("Error !");
    Qual.CurValue = 0;
    Qual.Text = "   ";
  }
  else
  {
    a = DeleteCharactersFromString(a, "\n\rOK");
    a = ExtractSubString(a, 2, " ");
    //print("  : \"" + a + "\"");

    int rssi = AsInteger(ExtractSubString(a, 1, ","));
    int ber = AsInteger(ExtractSubString(a, 2, ","));

    //print("rssi="+IntToStr(rssi) + " ber="+IntToStr(ber));
    if( rssi==99 )
    {
      Qual.CurValue = 0;
      Qual.Text = "   !";
    }
    else
    {
      Qual.CurValue = rssi;
      Qual.Text = " " + IntToStr(rssi) + RssiToDb(rssi) + "  " + IntToStr(ber);
    }
  }
}

//-----------------------------------------------------------------
//   . Sender -    .
//-----------------------------------------------------------------
void OnAutoPilotAction(int Sender)
{
  ReadSignalQual();
}

//-----------------------------------------------------------------
//  USSD 
//-----------------------------------------------------------------
void OnGetMTSBalance(TMonText Sender)
{
  if( GSMState()!=3 )
  {
    LMShowMessage2("   !");
    return;
  }

  if( Length(sms_ussd)==0 )
    sms_ussd = "*100#";
  if( ! InputString("  ()", sms_ussd) )
    return;

  String answer;
  if( ! ATCmd("atd" + sms_ussd + ";", answer ,3000) )
    LMShowMessage2("  AT  !");
  else
    LMShowMessage2(" : \"" + answer + "\"", "  ", false, false);
}

//-----------------------------------------------------------------
//     main()
//      
//-----------------------------------------------------------------
{
  //       SMS 
  ReceiveMessage();
  //       
  ReceiveRings();
/*
  String a;
  if( ! ATCmd("at",a,3000) )
    LMShowMessage2("Error !");
  else
    LMShowMessage2("\"" + a + "\"", " ", false, false);
*/
}
